package com.bs.logisticslnfoapi.controller;

import com.bs.logisticslnfoapi.bean.ResultBean;
import com.bs.logisticslnfoapi.bean.YunDaBean;
import com.bs.logisticslnfoapi.bean.jhy.JhyPhone;
import com.bs.logisticslnfoapi.bean.jhy.JhyPhonePushRequest;
import com.bs.logisticslnfoapi.bean.jhy.JhyPhoneStateRequest;
import com.bs.logisticslnfoapi.service.jhy.JhyService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @ClassName JhyPhoneController
 * @Description 居欢颜
 * @Author kael
 * @Date 2019/8/5 0005 上午 11:29
 * @Version 1.0
 **/
@RestController
@Slf4j
@CrossOrigin("*")
@RequestMapping(value ="/logistics/jhy/phone")
public class JhyController {

    @Autowired
    private JhyService jhyService;

    /**
     * 新增电话号码
     * @param appkey
     * @param version
     * @param data
     * @param sign
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/add", method = {RequestMethod.POST})
    @ResponseBody
    public ResultBean<Boolean> addPhone(String appkey,String version,String data,String sign) throws Exception{
        return jhyService.addPhone(data);
    }

    @RequestMapping("/pushPhone")
    public ResultBean<String> pushPhone(@RequestBody JhyPhonePushRequest jhyPhonePushRequest) throws Exception{
        return new ResultBean<String>(jhyService.pushPhone(jhyPhonePushRequest));
    }

    @RequestMapping("/pushSign")
    public ResultBean<String> pushPhone(@RequestBody JhyPhoneStateRequest jhyPhoneStateRequest) throws Exception{
        return new ResultBean<String>(jhyService.pushSign(jhyPhoneStateRequest));
    }
}
