package com.bs.logisticslnfoapi.controller;

import com.alibaba.fastjson.JSON;
import com.bs.logisticslnfoapi.bean.ApiLog;
import com.bs.logisticslnfoapi.bean.youxiansheng.YouXianShengGetPhoneParam;
import com.bs.logisticslnfoapi.service.log.LogService;
import com.bs.logisticslnfoapi.util.OkHttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author LiuJS
 * @Time 2021/4/28 10:44
 * @Desc 优鲜生接口
 * @Version 1.0
 */
@RestController
@Slf4j
@CrossOrigin("*")
@RequestMapping(value ="logistics/youxiansheng")
public class YouXianShengController {

    @Resource
    private LogService logService;

    /**
     * 获取订单信息接口
     * @param youXianShengGetPhoneParam
     * @return
     */
    @PostMapping("static/getAddress")
    public String getAddress(@RequestBody YouXianShengGetPhoneParam youXianShengGetPhoneParam) throws Exception {
        long startTime = System.currentTimeMillis();
        String requestParam = JSON.toJSONString(youXianShengGetPhoneParam);
        log.info("优鲜生获取订单信息接口传入参数:{}",requestParam);
        Map<String, String> queryMap = new HashMap<>(2);
        queryMap.put("orderId",youXianShengGetPhoneParam.getOrderId());
        queryMap.put("sign",youXianShengGetPhoneParam.getSign());
        //测试地址http://139.196.74.165:8074/static/getAddress
        String result = OkHttpUtil.get("https://applet.uxskj.com/static/getAddress", queryMap);
        log.info("优鲜生获取订单信息接口返回结果:{}",result);
        logService.install(ApiLog.builder()
                .requestMsg(requestParam)
                .responseMsg(result)
                .url("static/getAddress")
                .exTime(new Long((System.currentTimeMillis() - startTime)).intValue())
                .createTime(new Date())
                .requestType(1)
                .platform("YXS")
                .build());
        return result;
    }
}
