package com.bs.logisticslnfoapi.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bs.logisticslnfoapi.bean.ApiLog;
import com.bs.logisticslnfoapi.bean.yunda.YunDaRegisterSysBean;
import com.bs.logisticslnfoapi.bean.yunda.utils.ApiUtils;
import com.bs.logisticslnfoapi.service.log.LogService;
import com.bs.logisticslnfoapi.util.Enum.PlatformEnum;
import com.bs.logisticslnfoapi.util.HttpUtils;
import com.bs.logisticslnfoapi.util.OkHttpUtil;
import com.google.gson.Gson;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;

/**
 * 韵达接口<br>
 *
 * @className: YunDaController
 * @package: com.bs.logisticslnfoapi.controller
 * @author: kael
 * @date: 2019/11/27 0027 上午 10:07
 */
@RestController
@Slf4j
@CrossOrigin("*")
@RequestMapping(value ="/logistics/yunda")
public class YunDaController {

    @Autowired
    private LogService logService;

    /**
     * 韵达接口调用
     * @param yunDaBean
     * @return
     * @throws Exception
     */
    @RequestMapping("/yundaRegister")
    public Object yundaSign(@RequestBody YunDaRegisterSysBean yunDaRegisterSysBean) throws Exception{
        long startTime = System.currentTimeMillis();
        String host = yunDaRegisterSysBean.getUrl().trim();
        yunDaRegisterSysBean.setUrl("");
        Map<String,String> param = new HashMap<>();
        param = new Gson().fromJson(yunDaRegisterSysBean.getRequestParam(),param.getClass());
        param.put("appkey",yunDaRegisterSysBean.getAppkey());
        param.put("method",yunDaRegisterSysBean.getMethod());
        param.put("v",yunDaRegisterSysBean.getV());
        param.put("format",yunDaRegisterSysBean.getFormat());
        param.put("sign", ApiUtils.sign(param,yunDaRegisterSysBean.getSign()));
        log.info("韵达请求：{}",new Gson().toJson(param));
        //http请求
        String result = OkHttpUtil.get(host,param);
        log.info("韵达响应：{}",result);
        logService.install(ApiLog.builder()
                .requestMsg(yunDaRegisterSysBean.getFormat())
                .responseMsg(result)
                .url(host)
                .exTime(new Long((System.currentTimeMillis() - startTime)).intValue())
                .createTime(new Date())
                .requestType(1)
                .platform(PlatformEnum.YD.getEnValue())
                .build());
        return result;
    }
}
