package com.bs.logisticslnfoapi.controller;

import com.alibaba.fastjson.JSON;
import com.bs.logisticslnfoapi.bean.ApiLog;
import com.bs.logisticslnfoapi.bean.zhongtong.ZtoReceiveRequest;
import com.bs.logisticslnfoapi.service.log.LogService;
import com.bs.logisticslnfoapi.util.OkHttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.util.Date;

/**
 * 〈功能概述〉<br>
 *
 * @className: ZtoController
 * @package: com.bs.logisticslnfoapi.controller
 * @author: kael
 * @date: 2020/1/9 2:15 下午
 */
@RestController
@Slf4j
@CrossOrigin("*")
@RequestMapping(value = "/logistics/zto")
public class ZtoController {

    @Autowired
    private LogService logService;

    @Value("${sendmessageurl}")
    private String sendmessageurl;

    @PostMapping(value = "/callback/receive")
    public @ResponseBody String callBackReceive(@RequestBody ZtoReceiveRequest request) {
        long startTime = System.currentTimeMillis();
        String res = "";
        try {
            log.info("【中通短信回执传入参数】：{}",JSON.toJSONString(request));
            res = OkHttpUtil.postJson(sendmessageurl + "/sms/zto/receive", request);
            logService.install(ApiLog.builder()
                    .requestMsg(JSON.toJSONString(request))
                    .responseMsg(res)
                    .url("/logistics/zto/callback/receive")
                    .exTime(new Long((System.currentTimeMillis() - startTime)).intValue())
                    .createTime(new Date())
                    .requestType(2)
                    .platform("ZTO")
                    .build());
            log.info("【中通短信回执】：{}",res);
        } catch (Exception e) {
            log.error("receive callback error :", e);
            return "{\"success\":\"false\",\"errorCode\":\"100\",\"errorMsg\":\"系统错误\"}";
        }
        // 返回对象response ，JSON或者XML 取决于您服务注册的格式
        return res;
    }
}
