package com.bs.logisticslnfoapi.factory.smsPlatform;

import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @PackageName: com.bs.logisticslnfoapi.factory.smsPlatform
 * @ClassName: SmsPlatformFactory
 * @Description: 简单工厂_短信平台工厂类
 * @Author: liujs
 * @Date: 2020/05/18 上午 10:30
 * @Version: 1.0
 */
@Component
public class SmsPlatformFactory {
    @Resource
    private Map<String,BaseSmsPlatform> map = new ConcurrentHashMap<>();

    public BaseSmsPlatform getSmsPlatform(String smsPlatform){
        if (null == smsPlatform){
            return null;
        }
        return map.get(smsPlatform);
    }
}
