package com.bs.logisticslnfoapi.factory.smsPlatform.realize;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bs.logisticslnfoapi.bean.ApiLog;
import com.bs.logisticslnfoapi.bean.smsplatform.mengwang.MengWangSendSmsBean;
import com.bs.logisticslnfoapi.bean.smsplatform.mengwang.MengWangSmsStatusReportBean;
import com.bs.logisticslnfoapi.factory.smsPlatform.BaseSmsPlatform;
import com.bs.logisticslnfoapi.service.log.LogService;
import com.bs.logisticslnfoapi.util.OkHttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Date;

/**
 * @PackageName: com.bs.logisticslnfoapi.factory.smsPlatform.realize
 * @ClassName: MengWang
 * @Description: TODO
 * @Author: liujs
 * @Date: 2020/05/18 上午 11:19
 * @Version: 1.0
 */
@Slf4j
@Component("MengWang")
@RestController
public class MengWang implements BaseSmsPlatform {

    @Resource
    private LogService logService;

    @Value("${sendmessageurl}")
    private String sendMessageUrl;

    @Override
    public String sendSms(String params) {
        long startTime = System.currentTimeMillis();
        String url = "http://TSN19.800CT.COM:8901/sms/v2/std/single_send";
        MengWangSendSmsBean request = JSONObject.parseObject(params, MengWangSendSmsBean.class);
        String result;
        try {
            log.info("梦网发短信接口传入参数：{}",params);
            result = OkHttpUtil.postJson(url, request);
            log.info("梦网发短信接口返回参数：{}", result);
            logService.install(ApiLog.builder()
                    .requestMsg(JSON.toJSONString(request))
                    .responseMsg(result)
                    .url(url)
                    .exTime(new Long((System.currentTimeMillis() - startTime)).intValue())
                    .createTime(new Date())
                    .requestType(1)
                    .platform("MengWang")
                    .build());
        }catch (Exception e) {
            return "{\"result\":-10009,\"msgid\":0,\"custid\":\"\"}";
        }
        return result;
    }

    /**
     * 梦网平台短信回执接口
     * @param params 参数
     * @return 返回结果
     */
    @RequestMapping("/smsStatusReportByMengWang")
    public String smsStatusReport(@ModelAttribute MengWangSmsStatusReportBean params) throws Exception {
        long startTime = System.currentTimeMillis();
        //TODO
        String url = sendMessageUrl + "/smsStatusReportByMengWang";
        log.info("梦网短信回执传入参数为:{}",JSON.toJSONString(params));
        String result = OkHttpUtil.postJson(url, params);
        logService.install(ApiLog.builder()
                .requestMsg(JSON.toJSONString(params))
                .responseMsg(result)
                .url(url)
                .exTime(new Long((System.currentTimeMillis() - startTime)).intValue())
                .createTime(new Date())
                .requestType(2)
                .platform("MengWang")
                .build());
        log.info("【梦网短信回执】：{}", result);
        return result;
    }
}
