package com.bs.logisticslnfoapi.service.log.impl;

import com.alibaba.fastjson.JSON;
import com.bs.logisticslnfoapi.bean.ApiLog;
import com.bs.logisticslnfoapi.service.log.LogService;
import com.bs.logisticslnfoapi.util.rabbit.RabbitConfig;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 日志<br>
 *
 * @className: LogServiceImpl
 * @package: com.bs.logisticslnfoapi.service.log.impl
 * @author: kael
 * @date: 2019/10/23 0023 上午 9:37
 */
@Service
@Slf4j
public class LogServiceImpl implements LogService {

    @Autowired
    private AmqpTemplate rabbitTemplate;

    @Autowired
    private RabbitConfig rabbitConfig;

    @Override
    public void install(ApiLog log) {
        rabbitTemplate.convertAndSend(rabbitConfig.getApiLogQueueName(), JSON.toJSONString(log));
    }
}
