package com.bs.logisticslnfoapi.util;

import com.fasterxml.jackson.databind.JavaType;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * JSON帮助类
 *
 * @author taohaijun
 * @create 2018-03-28 9:32
 */
public class JSONUtils {
    private static final ObjectMapper mapper = new ObjectMapper();

    private JSONUtils() {
    }

    public static Map<String, Object> json2Map(String json) throws IOException {
        Map map = (Map) mapper.readValue(json, Map.class);
        return map;
    }

    public static String object2Json(Object object) throws IOException {
        return mapper.writeValueAsString(object);
    }

    public static <T> T json2Object(String json, Class<T> clazz) throws IOException {
        return mapper.readValue(json, clazz);
    }

    public static <T> List<T> json2List(String jsonStr, Class<T> cls) {
        List<T> objList = null;
        try {
            JavaType t = mapper.getTypeFactory().constructParametricType(
                    List.class, cls);
            objList = mapper.readValue(jsonStr, t);
        } catch (Exception e) {
        }
        return objList;
    }
}
