package com.bs.logisticslnfoapi.util;

import org.apache.tomcat.util.codec.binary.Base64;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class Md5Util {

	/** @return byte[16] */
	public static byte[] md5(byte[] bytes) {
		if (bytes == null)
			throw new IllegalArgumentException();
		try {
			MessageDigest digest = MessageDigest.getInstance("MD5");
			return digest.digest(bytes);
		} catch (Exception e) {
			return null;
		}
	}

	public static String makeSign(String data, String encode) throws NoSuchAlgorithmException, UnsupportedEncodingException {

		MessageDigest md = MessageDigest.getInstance("MD5");

		md.update(data.getBytes(encode));

		byte[] b = md.digest();

		return (new sun.misc.BASE64Encoder()).encode(b);

	}

	public static String doSign(String content, String charset, String keys) throws Exception{
		content = content + keys;
		System.out.println("content:"+content);
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(content.getBytes(charset));
		String str = new String(Base64.encodeBase64(md.digest()), charset);
		System.out.println("serverDigest:"+str);
		return str;
	}

	public static String doSign(String inStr) throws Exception{
		MessageDigest md5 = MessageDigest.getInstance("MD5");
		byte[] byteArray = inStr.getBytes("UTF-8");
		byte[] md5Bytes = md5.digest(byteArray);
		StringBuffer hexValue = new StringBuffer();
		for (int i = 0; i < md5Bytes.length; i++) {
			int val = ((int) md5Bytes[i]) & 0xff;
			if (val < 16) {
				hexValue.append("0");
			}
			hexValue.append(Integer.toHexString(val));
		}
		return hexValue.toString();
	}

	public static String caiNiaoDoSign(String content, String charset, String keys) {
		String sign = "";
		content = content + keys;
		try {
			MessageDigest md = MessageDigest.getInstance("MD5");
			md.update(content.getBytes(charset));
			sign = new String(Base64.encodeBase64(md.digest()), charset);
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		return sign;
	}

	/** @return byte[16] */
	public static byte[] md5(String s) {
		return md5(toBytes(s));
	}
	/** @return String[32] */
	public static String md5AsUpperHex(String s) {
		return md5AsUpperHex(toBytes(s));
	}
	/** @return String[32] */
	public static String md5AsLowerHex(String s) {
		return md5AsLowerHex(toBytes(s));
	}
	/** @return String[32] */
	public static String md5AsUpperHex(byte[] bytes) {
		return asHex(md5(bytes), false);
	}
	/** @return String[32] */
	public static String md5AsLowerHex(byte[] bytes) {
		return asHex(md5(bytes), true);
	}

	/* ------------------------- impl ------------------------- */

	private static byte[] toBytes(String s) {
		return (s != null ? s : "").getBytes(EscapeUtil.CHARSET_UTF8);
	}
	private static final char[] HEX_CHARS_LOWER = "0123456789abcdef".toCharArray();
	private static final char[] HEX_CHARS_UPPER = "0123456789ABCDEF".toCharArray();
	private static String asHex(byte[] bytes, boolean lowerCase) {
		if (bytes == null || bytes.length != 16)
			throw new IllegalArgumentException();

		char[] template = lowerCase ? HEX_CHARS_LOWER : HEX_CHARS_UPPER;
		char chars[] = new char[32];
		for (int i = 0; i < chars.length; i = i + 2) {
			byte b = bytes[i / 2];
			chars[i] = template[(b >>> 4) & 0xf];
			chars[i + 1] = template[b & 0xf];
		}
		return new String(chars);
	}

}
