package com.bs.logisticslnfoapi.util;

import com.alibaba.fastjson.JSON;
import com.bs.logisticslnfoapi.bean.ApiLog;
import com.bs.logisticslnfoapi.bean.pdd.PddRequest;
import com.bs.logisticslnfoapi.util.Enum.PlatformEnum;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import sun.misc.BASE64Encoder;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @ClassName PddUtil
 * @Description TODO
 * @Author Administrator
 * @Date 2019/8/29 0029 下午 13:55
 * @Version 1.0
 **/
@Slf4j
public class PddUtil {

    public static Object pddPush(String json, String partner_id, String secret, String url) throws Exception {
        Map<String,String> param = new HashMap<>(5);
        param.put("partner_id",partner_id);
        param.put("digest", PddUtil.pddDigest(json,secret));
        param.put("data", json);
        return OkHttpUtil.postJson(url.trim(), param);
    }

    public static <T extends PddRequest> T paramHandle(T pddRequest){
        pddRequest.setPartner_id(null);
        pddRequest.setSecret(null);
        pddRequest.setApiName(null);
        return pddRequest;
    }

    public static byte[] MD5(String s) {
        try {
            MessageDigest md5 = MessageDigest.getInstance("md5");
            md5.update(s.getBytes("UTF-8"));
            return md5.digest();
        } catch (NoSuchAlgorithmException e) {
//			throw e;
        } catch (UnsupportedEncodingException e) {
//			throw ExceptionUtil.unchecked(e);
        }
        return null;
    }

    public static String pddDigest(String data,String secret){
        String plainText = data+secret;
        return new String(new BASE64Encoder().encode(MD5(plainText)));
    }

}
