package com.bs.logisticslnfoapi.util;

import com.bs.logisticslnfoapi.bean.LogisticsBean;
import org.apache.commons.lang3.StringUtils;
import org.springframework.cglib.beans.BeanMap;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import java.io.StringWriter;
import java.lang.reflect.Field;

/**
 * @author taohaijun
 * @Description:
 * @date 2019/3/7 16:44
 */
public class RequestBuilder {
    public static String buildPayRequestXml(LogisticsBean logisticsBean) {
        StringBuilder sb = new StringBuilder();
        sb.append("<request>");
        sb.append("<mailNos>").append(logisticsBean.getMailNos()).append("</mailNos>");
        if(StringUtils.isNotEmpty(logisticsBean.getCnOrderCode())){
            sb.append("<cnOrderCode>").append(logisticsBean.getCnOrderCode()).append("</cnOrderCode>");
        }
        sb.append("<time>").append(logisticsBean.getTime()).append("</time>");
        sb.append("<desc>").append(logisticsBean.getDesc()).append("</desc>");
        sb.append("<action>").append(logisticsBean.getAction()).append("</action>");
        sb.append("<city>").append(logisticsBean.getCity()).append("</city>");

        sb.append("<stationName>").append(logisticsBean.getStationName()).append("</stationName>");
        sb.append("<stationContact>").append(logisticsBean.getStationContact()).append("</stationContact>");
        if(StringUtils.isNotEmpty(logisticsBean.getStationId())){
            sb.append("<stationId>").append(logisticsBean.getStationId()).append("</stationId>");
        }
        if(StringUtils.isNotEmpty(logisticsBean.getAuthCode())){
            sb.append("<authCode>").append(logisticsBean.getAuthCode()).append("</authCode>");
        }
        sb.append("<stationSource>").append(logisticsBean.getStationSource()).append("</stationSource>");
        sb.append("<partnerName>").append(logisticsBean.getPartnerName()).append("</partnerName>");
        sb.append("</request>");
        return sb.toString();
    }

    public static String beanToXml(Object obj) throws JAXBException {
        Field[] fields = obj.getClass().getDeclaredFields();
        String strXml = "";
        for(int i = 0 , len = fields.length; i < len; i++) {
            // 对于每个属性，获取属性名
            String varName = fields[i].getName();
            try {
                // 获取原来的访问控制权限
                boolean accessFlag = fields[i].isAccessible();
                // 修改访问控制权限
                fields[i].setAccessible(true);
                // 获取在对象f中属性fields[i]对应的对象中的变量
                Object o;
                try {
                    o = fields[i].get(obj);
                    if(o != null){
                        strXml += "<"+varName+">"+o+"</"+varName+">";
                    }
                } catch (IllegalAccessException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
                // 恢复访问控制权限
                fields[i].setAccessible(accessFlag);
            } catch (IllegalArgumentException ex) {
                ex.printStackTrace();
            }
        }
        return "<request>"+strXml+"</request>";
    }

    public static String beanToXml(Object obj,String head,String tail) throws JAXBException {
        Field[] fields = obj.getClass().getDeclaredFields();
        String strXml = "";
        for(int i = 0 , len = fields.length; i < len; i++) {
            // 对于每个属性，获取属性名
            String varName = fields[i].getName();
            try {
                // 获取原来的访问控制权限
                boolean accessFlag = fields[i].isAccessible();
                // 修改访问控制权限
                fields[i].setAccessible(true);
                // 获取在对象f中属性fields[i]对应的对象中的变量
                Object o;
                try {
                    o = fields[i].get(obj);
                    if(o != null){
                        strXml += "<"+varName+">"+o+"</"+varName+">";
                    }
                    System.err.println("传入的对象中包含一个如下的变量：" + varName + " = " + o);
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
                // 恢复访问控制权限
                fields[i].setAccessible(accessFlag);
            } catch (IllegalArgumentException ex) {
                ex.printStackTrace();
            }
        }
        return head+strXml+tail;
    }
}
