package com.bs.logisticslnfoapi.util;

import com.bs.logisticslnfoapi.bean.LogisticsResult;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;

/**
 * @author taohaijun
 * @Description:
 * @date 2019/3/7 16:44
 */
@Slf4j
public class ResponseParser {
    public static LogisticsResult parseResponseXml(String responseXml) throws DocumentException {
        if (StringUtils.isBlank(responseXml)) {
            log.warn("[warn] parseResponseXml failed - responseXml is blank.");
            return null;
        }

        LogisticsResult result = new LogisticsResult();

        Document document = DocumentHelper.parseText(responseXml);
        Element root = document.getRootElement();

        try {
            String resultCode = root.element("success").getText();
            if (StringUtils.equals(resultCode, "true")) {
                result.setSuccess(true);
            } else {
                result.setSuccess(false);
            }
        } catch (Exception e) {
            log.error("[error] parse success in parseResponseXml exception!", e);
            return result;
        }


        Element element = root.element("errorCode");
        if (element != null) {
            result.setErrorCode(element.getText());
        }

        element = root.element("errorMsg");
        if (element != null) {
            result.setErrorMsg(element.getText());
        }


        return result;
    }
}
