package com.bs.logisticslnfoapi;

import com.alibaba.fastjson.JSON;
import com.bs.logisticslnfoapi.bean.zhongtong.ZtoQueryMobileRequest;
import org.junit.Before;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.MvcResult;
import org.springframework.test.web.servlet.RequestBuilder;
import org.springframework.test.web.servlet.setup.MockMvcBuilders;
import org.springframework.web.context.WebApplicationContext;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.post;
import static org.springframework.test.web.servlet.result.MockMvcResultHandlers.print;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

/**
 * @ClassName LogisticsControllerTestes
 * @Description
 * @Author SunJJ
 * @Date 2020/5/13 14:44
 * @Version V1.0
 **/
public class LogisticsControllerTests extends LogisticslnfoApiApplicationTests {
    private MockMvc mvc;
    @Autowired
    private WebApplicationContext wac;

    @Before
    public void setUp() {
        mvc = MockMvcBuilders.webAppContextSetup(wac).build();
    }

    @Test
    public void ztoBillAnalysisTest() throws Exception {
        String billCode = "73130331552498";
        ZtoQueryMobileRequest ztoRequest = ZtoQueryMobileRequest.builder()
                .companyCode("")
                .billCode(billCode)
                .build();
        ztoRequest.setApiName("http://japi.zto.cn/billAnalysis");
        ztoRequest.setCompanyId("94bdc6dcc562403fb6a6ab0ff80c243b");
        ztoRequest.setKey("ceca789b0069");

        RequestBuilder request = post("/logistics/ztoBillAnalysis").contentType(MediaType.APPLICATION_JSON_UTF8).content(JSON.toJSONString(ztoRequest));
        MvcResult mvcResult = mvc.perform(request).andExpect(status().isOk()).andExpect(content().contentType("text/plain;charset=UTF-8")).andDo(print()).andReturn();
        System.out.println(mvcResult.getResponse().getContentAsString());
    }

    @Test
    public void ztoGetMobileTest() throws Exception {
        ZtoQueryMobileRequest ztoRequest = ZtoQueryMobileRequest.builder()
                .companyCode("1074")
                .billCode("680000000006")
                .build();
        ztoRequest.setApiName("http://58.40.16.122:8080/getMobileAndNameByBillCode");
        ztoRequest.setCompanyId("94bdc6dcc562403fb6a6ab0ff80c243b");
        ztoRequest.setKey("ceca789b0069");

        RequestBuilder request = post("/logistics/ztoGetMobile").contentType(MediaType.APPLICATION_JSON_UTF8).content(JSON.toJSONString(ztoRequest));
        MvcResult mvcResult = mvc.perform(request).andExpect(status().isOk()).andExpect(content().contentType("text/plain;charset=UTF-8")).andDo(print()).andReturn();
        System.out.println(mvcResult.getResponse().getContentAsString());
    }
}
